'
' GottliebCams routines Copyright (c) 2006 Star Wolf Innovations.
' All Rights Reserved.
' Author: Greywolf <greywolf@starSPAMwolfSTOP.com>
' The author releases this material to be redistributed only on a
' not-for-profit basis.  Credit given for routines used from
' this code collection would be greatly appreciated.
'
Option Explicit
' Gottlieb Cams routines.
' Drew a lot from BallyCams.
const emGottliebCamsVersion=3.2
' Last update: 2006:0522:1430
' * 3.0 => 3.2 RELEASE to be in sync with other *Cams routines
' The resets have been modified to be more authentic.
' 
' And away we go.
' **** Constants, with variables close by.
' Limits
const	GLOB_MAXBALLS=10	' no more than this
const	GLOB_MAXPLAYERS=4	' no more than this
const	GLOB_MAXBONUS=15	' Gottlieb topped out at 15

const	NPULSES=5		' Gottlieb's repeaters had 6 pulses
const GLOB_MAXREPLAYS=25
' Scoring

public	score_min		' minimum score
	score_min = 10		' currently unused

' Bonus
dim	bonus_style		' default: 0 (fast collect)
const	BONUS_FAST=0		' fast (5/cycle) collect
const	BONUS_SLOW=1		' slow (1/cycle) collect
const	BONUS_ARRAY=2		' user-defined - MUST FOR ARRAYS!

bonus_style = BONUS_FAST

' APPLIES TO SEQUENTIAL BONUS ONLY!!!
dim	collecting_bonus
const	COLL_NONE=0		' not currently collecting bonus
const	COLL_RESET=1	' decrement but do not score (always superfast)
const	COLL_DECR=2		' collecting and decrementing
const	COLL_KEEP=3		' collecting and keeping


' What the backbox says...
const	SHOOT_AGAIN="SHOOT AGAIN"
' Gottlieb says "SHOOT AGAIN".
' Williams says either/or.
'****
' Cam State
' The following ONLY apply to values resulting from a cam start

const	C_SMASK=&h0000000f
const	SCORE_R1=	&H0001	' only 1 has the 1 bit set
const	SCORE_R2=	&H0002	' only 10 has the 2 bit set
const	SCORE_R3=	&H0004	' only 100 has the 4 bit set
const	SCORE_R4=	&H0008	' only 1000 has the 128 bit set
' 	*** features ***
'* can we squeeze some bits out of the scoring?
' NOTE: VB likes to think that &H8000 is -32768 :/
const	C_ADDP=	&H00000010	' add a player
const	C_SPEC=	&H00000020	' score a special
const	C_REPLAY= &H00000040		' add a credit
const	C_DREPL=	&H00000080 ' take a credit
const	C_EJECT=	&H00000100	' cause a saucer to eject
const	C_ADDB=	&H00000200	' add bonus (calls add_bonus)
const	C_DECB=	&H00000400	' decrease bonus (calls dec_bonus)
const C_RTILT=	&H00000600	' reset tilt
const	C_RDROPS=	&H00000800	' reset drop targets
const	C_STEP=	&H00001000	' Thump a stepper
const	C_CGATE=	&H00002000	' close an open gate (calls close_gate)
const	C_LOADB=	&H00004000	' load the ball into the shooter
const	C_RSPSA=	32768	' reset Same Player Shoots Again
const	C_NEXT=	&H00010000	' go to next player/ball
const	C_GAMEON=	&H00020000	' engage game-on relay
const	C_GAMEOFF=	&H00040000	' true end-of-game
const C_RXREEL=	&H00080000	' reset reel pulse
const C_RSTATE=	&H00100000	' reset state
const C_USER1=	&H00200000	' User-defined cam pulse #1 - called from collect.
const C_USER2=	&H00400000	' User-defined cam pulse #2 - not.
const C_ADVBALL=&H00800000	' Advance the ball counter
const C_ADDBALL=&H01000000	' add a ball

const	C_FMASK=	&HFFFFFFF0	' feature mask

'*** CAM ENGINE
dim incam		' we in the cam engine already?
dim cp			' cam position
dim camstack(): redim camstack(NPULSES)

'*** SPECIFICS
dim	CurrentBank
dim	CurrentEject
dim	CurrentPost
dim	CurrentGate
dim	CurrentAltq
dim	CurrentBQueue
dim	CurrentScoring
dim	CurrentCycler
dim	CurrentBuilder

dim Ball	' ball on table

camtimer.interval = TIMER_GOTTLIEB
dim clight(7)

'dim x, l
'x = 0
'for each l in array(l_cam0,l_cam1,l_cam2,l_cam3,l_cam4,l_cam5,l_cam6,l_cam7)
'	set clight(x)= l
'	x = x + 1
'next

sub runcam()
	dim ao
	'showcams
	if incam then exit sub
	incam = true
	cp = 0
	camtimer.enabled = true
end sub

' user-settable routines
sub cuser1(p)
end sub

sub cuser2(p)
end sub

sub dostep(p)
end sub

' to override the blank cuser1 routine...
sub gcUserSet(s)
	executeglobal "sub cuser1(p): " & s & " p: end sub"
end sub

' and blank cuser2 routine
sub gcUserSet2(s)
	executeglobal "sub cuser2(p): " & s & " p: end sub"
end sub

' and blank dostep routine
sub gcStepperSet(s)
	executeglobal "sub dostep(p): " & s & " p: end sub"
end sub


sub clearcams()
	dim i
	for i = 0 to ubound(camstack)
		camstack(i) = 0
	next
end sub


' This needs some MAJOR rework for Gott tables!

sub camtimer_timer()
	dim o, r
	dim dt
	dim dtp	' drop target pointer

	addval camstack(cp)
	playsound S_camclick	' something suitably soft for a cam-hitting-relay
	me.enabled = false

	if (cp < ubound(camstack)) then
		camFlash 0
		dbx "Pending: " & C_pending & "; game state: " & TableState.game
		me.enabled = true
		cp = cp + 1
		incam = true
	else
		' clear possible state
		clearcams
		CurrentBank = NULL
		CurrentGate = NULL
		incam = false
		emAltQChange ALTQ_CAM
		camFlash 1
		' check for state here, in this order:
		' 1.  Drop targets
		' 2.  Eject holes
		' 3.  Bonus
		' 4.  Drain
		' NOTE:  This should probably be more of a
		' evaldrops routine to see if we should even
		' reset them.
		' ** 0. RESET - TOP PRIORITY
		dt = emCheckDrops
		if (c_pending AND PEND_RESET) then
			r = 0
			for o = 0 to Scores.maxplayers
				if Scores.score(o) <> 0 then r = r + 1
			next
			if (nbqueue >= 0) then
				for each o in BBonusQ
					if o.bonus then r = r + 1
				next
			end if
			if (r > 0 or nreset > 0) then
				camstack(1) = C_RXREEL
				camstack(2) = C_RXREEL
				camstack(3) = C_RXREEL
				camstack(4) = C_RXREEL
				camstack(5) = C_RXREEL
			else
				emPend PEND_RESET, FALSE
				init_ball
			end if
			runcam
		' ** 1.  Drop targets
		elseif (not isEmpty(dt)) then
			for each dtp in dt
				if (not isNull(dtp)) then
					camstack(dtp.aux) = C_RDROPS
				end if
			next
			runcam
			exit sub
		end if
		' ** 2. Eject Holes
		dbx "Pending: " & C_pending & "; game state: " & TableState.game
		if (c_pending AND PEND_EJECT) then
			emScoreSaucers CurrentEject
			emPend PEND_EJECT, FALSE
			exit sub
			' insert eject handler here
		' ** 4. Bonus
		elseif (c_pending AND PEND_BONUS) then
			emCollect bonus_style
		' ** 5. Drain
		elseif (c_pending AND PEND_DRAIN) then
			Drain_Hit
		end if
	end if
	dbx "Pending: " & C_pending & "; game state: " & TableState.game
end sub

dim cam_routine

sub set_camroutine(x)
	cam_routine = x
end sub

sub camflash(state)
	if (cam_routine <> "") then
		eval(getref(cam_routine)(state))
	end if
end sub

' addval - the world is inside this call.

const	ADD_ON	= 1
const	ADD_OFF	= 2
const ADD_PULSE	= 3

sub addval(v)
	addval_on v, ADD_PULSE
end sub

dim resets
sub addval_on(v, down)
' down: TRUE, engages the relay (play the sound)
' 	  FALSE, disengage the relay (flip the reel)

	dim f	' feature
	dim s	' score
	dim x	' whatever
	dim y	' whatever else

	s = (v and C_SMASK)

	f = (v and C_FMASK)

	if (v = TRUE) then dd "addval", "v = TRUE!  WTF?!?"

	' Potentially this part could be moved to emCORE.
	' ** simulchimes:  DONE! :)
	if (tablestate.game = GAME_ON) and (not tablestate.tilted) then
		x = ((Scores.Score(Scores.curplayer) \ minscore) mod 10)
		y = ((Scores.score(Scores.curplayer) \ (minscore * 10) mod 10))
		if (s and SCORE_R1) then
			if (down and ADD_ON) then
				playsound S_highchime
				if (x = 9) then 
					playsound S_midchime
					if (y = 9) then
						playsound S_lowchime
					end if
				end if
			end if
			if (down and ADD_OFF) then
				Scores.Creel.Addvalue(minscore)
				addscore minscore
			end if
		end if
		x = ((Scores.score(Scores.curplayer) \ (minscore * 10) mod 10))
		if (s and SCORE_R2) then
			if (down and ADD_ON) then
				playsound S_midchime
				if (x = 9) then playsound S_lowchime: end if
			end if
			if (down and ADD_OFF) then
				Scores.Creel.AddValue(minscore * 10)
				addscore minscore * 10
			end if
		end if
		if (s and SCORE_R3) then
			if (down and ADD_ON) then playsound S_lowchime
			if (down and ADD_OFF) then
				Scores.Creel.AddValue(minscore * 100)
				addscore minscore * 100
			end if
		end if
		if (s and SCORE_R4) then
			if (down and ADD_ON) then playsound S_altlowchime
			if (down and ADD_OFF) then
				Scores.Creel.AddValue(minscore * 1000)
				addscore minscore * 1000
			end if
		end if
	end if

	'  **** FEATURES ****
	if (down and ADD_ON) then
		if (f and C_ADDP) then emAddPlayer

		if (f and C_REPLAY) then emAddReplay
		
		if (f and C_DREPL) then Scores.take_replay

		if (f and C_SPEC) then scores.score_Special

		if (f and C_EJECT) then emClearSaucers	CurrentEject
	' note: C_RTILT = C_ADDB or C_DECB.  must check vs. mask.
		if ((f and C_RTILT) = C_ADDB) then
			emAddBonus CurrentBQueue, (Scores.didscore <> 0)
		end if

		if ((f and C_RTILT) = C_DECB) then emTakeBonus(CurrentBQueue)

		if (f and C_RDROPS) then emResetDrops CurrentBank

	'		if (f and C_DPOST) then emSetPost false
	' don't know of any gott tables that use a post...

		if (f and C_CGATE) then emCloseGate CurrentGate

		if (f and C_LOADB) then 
			emLoadBall
		end if

		if (f and C_RSPSA) then TableState.shootagain false

		if (f and C_NEXT) then emNextUp

		if (f and C_RXREEL) then
			if (resets) then
				if (nreset > 0) then
					nreset = nreset - 1
					playsound s_pstep
					TableState.addmatch
				end if
			end if
			' XXX reset needs to reset only p1, p2 then p3, p4 if
			' applicable.
			for each x in Bscore
				resets = x.reset
				x.reel(0).timerenabled = true
			next
		end if

		if (f and C_GAMEOFF) then
			' light game over here; delay until then
			TableState.tilt_style = TILT_NONE
			TableState.gameover 1
			TableState.tilt_style = TILT_ALL
		end if

		if (f and C_ADDBALL) then
			emNextBall TRUE
		end if

		if (f and C_USER1) then cuser1 cp

		if (f and C_USER2) then cuser2 cp

		if ((f and C_RTILT) = C_RTILT) then 
			emTiltReset
		end if

		if (f and C_STEP) then dostep cp
		
		if (f and C_ADVBALL) then
			playsound S_bstep
		end if

		if (f and C_GAMEON) then 
			TableState.game = GAME_ON
			emTiltReset
		end if
	end if
	' can't do elseif here! d'oh!
	if (down and ADD_OFF) then
		if (f and C_ADVBALL) then
			playsound S_bstep
			emNextBall FALSE
		end if
	end if
end sub

sub add_nx (n, x, force)
	dim pp		  ' position pointer

	if (n AND C_SMASK) AND _
		(TableState.tilted OR (TableState.game <> GAME_ON)) then
		exit sub
	end if

	if (incam) and not force then exit sub

	for pp = 1 to 5
		if (x > 0) then
			camstack(pp) = camstack(pp) or n
		end if
		x = x - 1
	next

	runcam
end sub

' add_nxe:  Add the requested value (n) x number of times at the END
' of the cycle.	 Bally liked to do this a lot.

sub add_nxe (n, x, force)
	dim pp

	if (n AND C_SMASK) AND _
		(TableState.tilted OR (TableState.game <> GAME_ON)) then
			exit sub
	end if

	if (incam) and not force then exit sub

	for pp = 5 to 1 step -1
		if (x > 0) then
			camstack(pp) = camstack(pp) or n
		end if
		x = x - 1
	next

	runcam
end sub

' some simple routines:
'

sub adv3 (n)
	add_nxe n or C_ADDB, 3, true
end sub

sub add3 (n)
	add_nx n, 3, true
end sub

sub add3b (n)
	camstack(5) = C_ADDB
	add_nx n, 3, true
end sub

sub add3_slow(n)
	camstack(1) = camstack(1) or n
	camstack(3) = camstack(3) or n
	camstack(5) = camstack(5) or n
end sub


sub add5 (n)
	add_nx n, 5, true
end sub

sub add5b (n)
	camstack(5) = C_ADDB
	add_nx n, 5, true
end sub


' GOTTLIEB
' score an array of lights...
sub score_collection(coll, litv, unlitv)
dim n, x

	n = 0

	if (TableState.tilted OR (TableState.game <> GAME_ON)) then exit sub

	for each x in coll
		if (emCheck(x)) then
			camstack(n) = camstack(n) OR litv
		else
			camstack(n) = camstack(n) OR unlitv
		end if
		n = n + 1
	next
	runcam
end sub

' bonus collection
' Collecting in the drain or other retractor...
' SEQUENTIAL ONLY

Public sub emCollect (how)
	dim x, flags

	if nbqueue < 0 then exit sub

	if (isNull(CurrentBQueue)) then exit sub
	if (tablestate.tilted) or (tablestate.game < GAME_ON) then
		x = 0
	else
		x = CurrentBQueue.worth
	end if

	if (CurrentBQueue.bonus <= 0) then exit sub

	camstack(1) = C_USER1
	camstack(2) = C_USER1
	camstack(3) = C_USER1
	camstack(4) = C_USER1
	camstack(5) = C_USER1

	emPend PEND_BONUS, TRUE
	if (how = BONUS_ARRAY) then
' force a short circuit and let the drain handler work its magic
		runcam
		exit sub
	elseif (how = BONUS_SLOW) then
		' single
		camstack(1) = camstack(1) or x
		camstack(5) = camstack(5) or C_DECB
		' now we tweak it:
		select case CurrentBQueue.multiplier
		case 2
			camstack(2) = camstack(2) or x
		case 3
			camstack(2) = camstack(2) or x
			camstack(3) = camstack(3) or x
		end select
	elseif (how = BONUS_FAST) then
		select case CurrentBQueue.multiplier
		case 1
			if (CurrentBQueue.bonus >= 1) then
				camstack(1) = camstack(1) or x or C_DECB
			end if
			if (CurrentBQueue.bonus >= 2) then
				camstack(2) = camstack(2) or x or C_DECB
			end if
			if (CurrentBQueue.bonus >= 3) then
				camstack(3) = camstack(3) or x or C_DECB
			end if
			if (CurrentBQueue.bonus >= 4) then
				camstack(4) = camstack(4) or x or C_DECB
			end if
			if (CurrentBQueue.bonus >= 5) then
				camstack(5) = camstack(5) or x or C_DECB
			end if
		case 2
			camstack(1) = camstack(1) or x
			camstack(2) = camstack(2) or x or C_DECB
			if (CurrentBQueue.bonus > 1) then
				camstack(3) = camstack(3) or x
				camstack(4) = camstack(4) or x
				camstack(5) = camstack(5) or C_DECB
			end if
		case 3
			camstack(1) = camstack(1) or x
			camstack(2) = camstack(2) or x
			camstack(4) = camstack(4) or x
			camstack(5) = camstack(5) or C_DECB
		case 4
			camstack(1) = camstack(1) or x
			camstack(2) = camstack(2) or x
			camstack(3) = camstack(3) or x
			camstack(4) = camstack(4) or x
			camstack(5) = camstack(5) or C_DECB
		end select
	end if
	if TableState.game = GAME_TRANS then
		camstack(5) = C_GAMEON
	end if
	collecting_bonus = COLL_NONE
	emPend PEND_BONUS, FALSE	' should get reset to TRUE by the drain if
						' there is anything left to collect
	runcam
end sub

' The calling routine will have to pass this in piecemeal.
' This function returns the number of collections actually done.
' *** finished!

function emCollect_array(bc, bv, alen, mul, byref off)
' bc:  bonus to collect
' bv:  bonus value per item
' alen: maximum to attempt per run
' mul: multiplier
' off = offset from start of bonus array

	dim x, n, l, v, o

	l = sizeof(bc)

	if (tablestate.tilted) or (tablestate.game < GAME_ON) then
		v = 0
	else
		v = bv
	end if

	n = 0
	o = off
	if (off > l) then
		emCollect_Array = 0
		exit function
	end if

	select case mul
	case 1
	for n = 0 to (min(max(0, l - off) , alen - 1))
			if (emCheck(bc(n+off))) then
				if (alen = 6) then
					camstack(n) = camstack(n) OR v
				else
					camstack(n+1) = camstack(n+1) or v
				end if
			end if
			o = o + 1
			if (alen = 6) then
					camstack(n) = camstack(n) OR C_STEP
			else
					camstack(n+1) = camstack(n+1) or C_STEP
			end if
		next
	case 2
	for n = 0 to (min(max(0, l - off) , 2))
		if (emCheck(bc(n+off))) then
				camstack(n*2) = camstack(n*2) OR v
				camstack((n*2)+1) = camstack((n*2)+1) OR v
			end if
		camstack((n*2)+1) = camstack((n*2)+1) or C_STEP
			o = o + 1
		next
	case 3
	for n = 0 to min(max(0, l - off), 1)
			if (emCheck(bc(n+off))) then
				camstack(n*3) = camstack(n*3) OR v
				camstack((n*3)+1) = camstack((n*3)+1) OR v
				camstack((n*3)+2) = camstack((n*3)+2) OR v
			end if
		camstack((n*3)+2) = camstack((n*3)+2) or C_STEP
			o = o + 1
		next
	end select

	off = o
	emCollect_Array = max(0, n)
'	dd "emCollectArray", "returning " & emCollect_Array
	if TableState.game = GAME_TRANS then
		camstack(5) = camstack (5) or C_GAMEON
	end if
	runcam
end function

' Arrays of stuff like in Royal Flush will have to be handled in the table.  It
' It doesn't happen often enough by comparison to the other two above.

'** game init **
dim nreset: nreset = 0

' init the game - GOTTLIEB style!
sub emGameReset()
	dim i

	emPend PEND_RESET, TRUE
	if (scores.maxplayers > 0) then
		nreset = ((5 - (nballs - tablestate.ballsleft)) * 4) + TableState.playerup + 10
		resets = 0
	end if

'	if (Scores.reel(0).timerinterval <> (int(camtimer.interval * 0.9))) then
'		Scores.reel(0).timerinterval = camtimer.interval * 0.9
'	end if

	CurrentBank = NULL
	CurrentGate = NULL

	camstack(1) = C_RXREEL or camstack(1)
	camstack(2) = C_RXREEL or camstack(2)
	camstack(3) = C_RXREEL or camstack(3)
	camstack(4) = C_RXREEL or camstack(4)
	camstack(5) = C_RXREEL or camstack(5)

	if (scores.maxplayers <> 0) then
		TableState.setball nballs
		TableState.addaball FALSE
	else
		if (TableState.add_a_ball = 0) then
			TableState.setball (nballs + 1)
		end if
	end if
	TableState.setcanplay 0
	TableState.nplayers = 0
	TableState.showmatch false
	TableState.gameover false	' only sets gamestate to TRANS
' need to set this to check each drop's .aux variable and only reset there.
	if (ubound(BDrop) >= 0) then
		for each i in BDrop
			camstack(i.aux) = camstack(i.aux) OR C_RDROPS
		next
	end if
	emCloseGate NULL
	emBonusMX NULL, 1
	emBuilderReset CurrentBuilder, TRUE
	emCyclerSet NULL, TRUE
	TableState.setplayer 0
	emTiltReset
	game_start	' must be provided by table
	runcam
end sub

 ' CHANGES for Gottlieb:
 ' - gottlieb never reset any of the lights.
sub emEndGame
	dim s, m
' dd "emEndGame", "players: " & tablestate.nplayers
	m = "matches: "
	if TableState.nplayers > 0 then
		for s = 1 to TableState.nplayers
		m = m & tablestate.checkmatch(scores.score(s)) & " "
			if TableState.checkmatch(Scores.score(s)) then
				camstack(s+1) = (camstack(s+1) OR C_REPLAY)
			end if
		next
	end if
	TableState.showmatch true
	TableState.tilt false
	TableState.game = GAME_TRANS
	camstack(5) = camstack(5) or C_GAMEOFF
'	TableState.setball 0
	emBuilderReset CurrentBuilder, FALSE
	emCyclerSet NULL, FALSE
'	emFLights FALSE
	runcam
	dbx m
	game_end	' must be provided by table
				' may very well handle the single-player end game here.
end sub

sub emAddPlayer()
	if Scores.didscore OR (TableState.Game <> GAME_ON) then
		emGameReset
		exit sub
	end if
	if TableState.addplayer then
		playsound S_addplayer
		Scores.take_replay
	end if
end sub

function StartButton(n)
	StartButton = false
	if (n = 0) then
		if (emTakeReplay() = FALSE) then
			exit function
		end if
	end if
	if (Scores.check_replay = FALSE) then exit function
	camstack(0) = camstack(0) or C_ADDP
	runcam
	StartButton = true
end function

sub emNextBall(inc)	' FOR SINGLE-PLAYER TABLES
	if (inc) then
		TableState.addball true
	else
		if (TableState.IsLastBall AND Scores.didscore) then
			if(TableState.checkmatch(Scores.score(0))) then
				addval C_REPLAY
			end if
			TableState.showmatch TRUE
			TableState.addball FALSE
			addval C_GAMEOFF
			exit sub
		end if
		TableState.addball false
	end if
end sub

' this needs to be handled with an altq.  Gott tables ALWAYS
' rotate thru the players.

sub emNextUp()	' FOR MULTI-PLAYER TABLES

	dim a, n, x, y

	if NOT Scores.didscore then
		exit sub
	end if

	CurrentGate = NULL
	CurrentBank = NULL
	camstack(5) = camstack(5) or C_CGATE
' tilt reset gets handled at the end of a bonus collect cycle...
' once a score is made by any player, ALL players are considered
' to have scored.

	n = Tablestate.playerup
	a = TableState.islastball
	if (a) then
		clearcams
		addval C_CGATE
		TableState.setplayer -1	'clear all playerup lights
' I despise this hack, but for authenticity it is necessary.
		a = TableState.checkmatch(Scores.score(0))
dbx "a = " & a & "; Scores.score(0) = " & Scores.score(0)
		if a then
			addval C_REPLAY
		end if
		TableState.gameover true
		emEndGame			' handles the match routine
		exit sub
	end if
	TableState.advb_gottlieb
	if (scores.curplayer = 0) then Tablestate.advb true
	TableState.addmatch

	if (scores.maxplayers = 1) then
		if (cp = 2) then
			if (tablestate.nplayers = 1) then
				if (n) then
					y = 2
				else
					y = 0
				end if
			else
				y = 3
			end if
		end if
	else
		y = scores.curplayer - tablestate.nplayers 
	end if
'	dd "Gottlieb::emNextUp", "scores.curplayer = " & scores.curplayer & _
'		vbNewLine & "scores.maxplayers = " & scores.maxplayers & _
'		vbNewLine & "tablestate.nplayers = " & tablestate.nplayers & _
'		vbNewLine & "y = " & y & "; n = " & n & "; cp = " & cp
	for x = 0 TO y
		camstack(2 + x) = camstack(2 + x) or C_NEXT
	next
' player-made routine
' handles retracting bonus, resetting bonus multipliers,
' and re-initialising the table lights
	Table_NextUp
end sub

'#### HIGH SCORE ROUTINES.
dim show_hiscore, hiscore, def_hiscore, hidate
	hidate = #11/11/1979#
	'# DEFAULT HIGH SCORE IS SET IN configure_scores
	'# HIGH SCORE CONFIG IS IN configure_table


sub display_hiscore
	if not (isobject(x_hiscore)) then exit sub
	if hiscore = "" then hiscore = def_hiscore
	if (show_hiscore) then
		x_hiscore.text = FormatNumber(hiscore, 0, 0, 0, TRUE) &_
			" " & hidate
	else
		x_hiscore.text = ""
	end if
end sub

sub update_hiscore(reset, replay)
	dim n

	if reset then
		dd "high score reset", "Resetting high score to " & def_hiscore
		hiscore = def_hiscore
		hidate = Date()
	else
		for n = 0 to tablestate.nplayers
			if (scores.score(n) > hiscore) then
				hiscore = scores.score(n)
				hidate = Date()
				if (replay) then
					camstack(5) = camstack(5) OR C_REPLAY
				end if
			end if
		next
	end if
	display_hiscore
end sub

sub gcSlamTilt()
	dim n
	emPend PEND_DRAIN, FALSE
	emPend PEND_BONUS, FALSE
	TableState.tilt_policy = TILT_ENDS_GAME
'	ndbx x_camdb, "emCheck(TableState.ptilt) =" & emCheck(TableState.ptilt), TRUE
	tilter.tilt TRUE
	TableState.tilt_style = TILT_ALL
	bqueue.setmx 1
	game_end
	TableState.ShowCanPlay TRUE
	TableState.ShowPlayer 4
	TableState.tilt_policy = TILT_BALL_ONLY
	TableState.shootagain FALSE
'	emClear tablestate.ptilt
end sub
