'*******************************************************************************
'******************************    LEDWIZ TOOLBOX   ****************************
'***************************     ROSVE 21 JAN 2012     *************************
'*******************************************************************************


' LedWiz Toolbox Commands

' ------------------------------------------------------------------------------
' LedWSetAllOff
' Turn off all outputs

' ------------------------------------------------------------------------------
' LedWSet Output1, Output2, State, Delay
'   Set output 3 ON -->  LedWSet 3,3,1,0
'   Set output 1 to 3 ON, 500ms delay -->  LedWSet 1,3,1,500 
'   Set output 3 to 4 OFF -->  LedWSet 3,4,0,0

'LedWFlash Output1, Output2, Repeats, On Duration, Off Duration, Delay
'   Flash output 2 one time, on for 500 ms --> LedWFlash 2,2,0,500,0
'   Flash output 2 to 4 four times, on for 100 ms, off for 250 ms --> LedWFlash 2,4,4,100,250
'------------------------------------------------------------------------------

'LedWRGBSet Output, R, G, B, TransitionTime, Delay
'   Set RGB intensity for an RGB LED
'   Set output 20 to RGB values 48,24,12 with a 500ms ramp time and 1000ms delay --> LedWRGBSet 20,48,24,12,500,1000
'   Set output 23 to RGB values 48,0,48 without ramptime --> LedWRGBSet 2,48,0,48,0,0

'LedWRGBFlash Output, Repeats, On Duration, Off Duration, R, G, B, Transition Time, Delay
'   Flash RGB LED output 20 with RGB values 24,48,24 three times. stay on for 150ms and off for 75ms.
'         transition time between the states is 250ms --> LedWRGBFlash 20, 3, 150, 75, 24, 48, 24, 250,0
'-------------------------------------------------------------------------------

'LedWIntensitySet Output, Intensity, TransitionTime, Delay
'   Set intensity for an output
'   Set output 20 to Intensity 48 with a 500ms ramp time LedWIntensitySet 20,48,500,0
'   Set output 23 to Intensity 36 without ramptime, 500ms delay --> LedWIntensitySet 23,36,0,500

'LedWIntensityFlash Output, Repeats, On Duration, Off Duration, Intensity, Transition Time, Delay
'   Flash output 20 with intensity value 48 three times. stay on for 150ms and off for 75ms.
'         transition time between the states is 250ms --> LedWIntensityFlash 20, 3, 150, 75, 48, 250,0
'--------------------------------------------------------------------------------


' **********************************************************************************************************************
' ******************************** Put your LedWiz Output name declarations here ***************************************
' **********************************************************************************************************************
const LedW_Start = "1"			'Start Button
const LedW_Launch = "2"			'Launch Ball Button
const LedW_CRFlash = "3"		'Center Right Flasher - Red
const LedW_LFlipper = "6"		'Left Flipper
const LedW_RFlipper = "7"		'Right Flipper
const LedW_Knocker = "8"		'Knocker
const LedW_Strobe = "9"			'Strobe Light
const LedW_LSling = "10"		'Left Slingshot
const LedW_RSling = "11"		'Right Slingshot
const LedW_Shaker = "12"		'Shaker Motor
const LedW_RGBFButton = "13"		'RGB Flipper Red
const LedW_GearMotor = "16"		'Gear Motor
const LedW_LBumper = "17"		'Left Bumper
const LedW_RBumper = "18"		'Right Bumper
const LedW_LNBumper = "19"		'Less Noisy Bumper
const LedW_CBumper = "20"		'Back End / Center Bumper
const LedW_CFlash = "21"		'Center Flasher - Red
const LedW_CLFlash = "24"		'Center Left Flasher - Red
const LedW_ORFlash = "27"		'Outside Right Flasher - Red
const LedW_OLFlash = "30"		'Outside Left Flasher - Red



' **********************************************************************************************************************
' **********************************************************************************************************************
' **********************************************************************************************************************


const LedWVersion=2
Dim LWTime:LWTime=LedWTimer.interval
Dim LedWMaxOutputs:LedWMaxOutputs=32
Dim LedWActive:LedWActive=1
Dim LedWmem (32,12)
'1-State
'2-Repeats
'3-On Duration
'4-Off Duration
'5-State Mem (mem, mem)
'6-OnDur Mem
'7-OffDur Mem
'8-Type         0=Deactivate   1=RGB    2=Intensity   3=On/Off
'9-Steps (Steps, Speps)
'10-Rstate, Gstate.Bstate
'11-RstateMem, GstateMem, BstateMem
'12-Start delay

Dim LedWn(48)
LedWn(0)="00"
LedWn(1)="01":LedWn(2)="02":LedWn(3)="03":LedWn(4)="04":LedWn(5)="05":LedWn(6)="06":LedWn(7)="07":LedWn(8)="08"
LedWn(9)="09":LedWn(10)="10":LedWn(11)="11":LedWn(12)="12":LedWn(13)="13":LedWn(14)="14":LedWn(15)="15":LedWn(16)="16"
LedWn(17)="17":LedWn(18)="18":LedWn(19)="19":LedWn(20)="20":LedWn(21)="21":LedWn(22)="22":LedWn(23)="23":LedWn(24)="24"
LedWn(25)="25":LedWn(26)="26":LedWn(27)="27":LedWn(28)="28":LedWn(29)="29":LedWn(30)="30":LedWn(31)="31":LedWn(32)="32"
LedWn(33)="33":LedWn(34)="34":LedWn(35)="35":LedWn(36)="36":LedWn(37)="37":LedWn(38)="38":LedWn(39)="39":LedWn(40)="40"
LedWn(41)="41":LedWn(42)="42":LedWn(43)="43":LedWn(44)="44":LedWn(45)="45":LedWn(46)="46":LedWn(47)="47":LedWn(48)="48"


Sub LedWSetAllOff ()
  dim lwi,lwii
  For lwi=1 To 32
   For lwii=1 To 12
     LedWmem(lwi,lwii) = 0
   Next
  Next
  If LedWActive=1 Then LedControl.Command = "SBA:0,0,0,0,0"
End Sub

Sub LedWSet (ByVal OPstart, Byval OPend, Byval State, Byval SD)
   Dim lwi 
   For lwi=Cint(Right(OPstart,2)) To Cint(Right(OPend,2))
      LedWmem(lwi,1)=State
      LedWmem(lwi,2)=0
      LedWmem(lwi,8)=3
      LedWmem(lwi,12)=Int(SD/LWTime)
   Next
End Sub

Sub LedWFlash (ByVal OPstart, Byval OPend, Byval Repeats, Byval OnDur, ByVal OffDur, Byval SD)
   Dim lwi   
   For lwi=Cint(Right(OPstart,2)) To Cint(Right(OPend,2))
      LedWmem(lwi,1)=1
      LedWmem(lwi,2)=Repeats
      LedWmem(lwi,3)=Int(OnDur/LWTime)
      LedWmem(lwi,4)=Int(OffDur/LWTime)
      LedWmem(lwi,6)=Int(OnDur/LWTime)
      LedWmem(lwi,7)=Int(OffDur/LWTime)
      LedWmem(lwi,8)=3
      LedWmem(lwi,12)=Int(SD/LWTime)
   Next
End Sub

Sub LedWRGBSet (ByVal OPstart, ByVal R, ByVal G, ByVal B, ByVal Time, Byval SD)
   If Time<1 Then Time=1
   Dim lwi   
   lwi=Cint(Right(OPstart,2))
      LedWmem(lwi,1)=1
      LedWmem(lwi,2)=0
      LedWmem(lwi,3)=0
      LedWmem(lwi,4)=0
      LedWmem(lwi,6)=0
      LedWmem(lwi,7)=0
      LedWmem(lwi,8)=1

      ' To values
      LedWmem(lwi,11)=R
      LedWmem(lwi+1,11)=G
      LedWmem(lwi+2,11)=B
      LedWmem(lwi,5)=R
      LedWmem(lwi+1,5)=G
      LedWmem(lwi+2,5)=B
      'Inrements per step
      LedWmem(lwi,9)=(R-LedWmem(lwi,10))/(Time/LWTime)
      LedWmem(lwi+1,9)=(G-LedWmem(lwi+1,10))/(Time/LWTime)
      LedWmem(lwi+2,9)=(B-LedWmem(lwi+2,10))/(Time/LWTime)
      LedWmem(lwi,12)=Int(SD/LWTime)
End Sub

Sub LedWRGBFlash (ByVal OPstart, Byval Repeats, Byval OnDur, ByVal OffDur, ByVal R, ByVal G, ByVal B, ByVal Time, Byval SD)
   If Time<1 Then Time=1
   Dim lwi   
   lwi=Cint(Right(OPstart,2))
      LedWmem(lwi,1)=1
      LedWmem(lwi,2)=Repeats
      LedWmem(lwi,3)=Int(OnDur/LWTime)
      LedWmem(lwi,4)=Int(OffDur/LWTime)
      LedWmem(lwi,6)=Int(OnDur/LWTime)
      LedWmem(lwi,7)=Int(OffDur/LWTime)
      LedWmem(lwi,8)=1
      ' To values
      LedWmem(lwi,11)=R
      LedWmem(lwi+1,11)=G
      LedWmem(lwi+2,11)=B
      LedWmem(lwi,5)=R
      LedWmem(lwi+1,5)=G
      LedWmem(lwi+2,5)=B
      'Inrements per step
      LedWmem(lwi,9)=(R)/(Time/LWTime)
      LedWmem(lwi+1,9)=(G)/(Time/LWTime)
      LedWmem(lwi+2,9)=(B)/(Time/LWTime)
      LedWmem(lwi,12)=Int(SD/LWTime)
End Sub

Sub LedWIntensityFlash (ByVal OPstart, Byval Repeats, Byval OnDur, ByVal OffDur, ByVal I, ByVal Time, Byval SD)
   If Time<1 Then Time=1
   Dim lwi   
   lwi=Cint(Right(OPstart,2))
      LedWmem(lwi,1)=1
      LedWmem(lwi,2)=Repeats
      LedWmem(lwi,3)=Int(OnDur/LWTime)
      LedWmem(lwi,4)=Int(OffDur/LWTime)
      LedWmem(lwi,6)=Int(OnDur/LWTime)
      LedWmem(lwi,7)=Int(OffDur/LWTime)
      LedWmem(lwi,8)=2
      LedWmem(lwi,11)=I ' Ivalue mem
      LedWmem(lwi,5)=I ' To Ivalue
      'Inrements per step
      LedWmem(lwi,9)=(I)/(Time/LWTime) ' time steps
      LedWmem(lwi,12)=Int(SD/LWTime)
      If LedWActive=1 then LedControl.Command = "S" & LedWn(lwi) & ":1"' Turn the output on
End Sub

Sub LedWIntensitySet (ByVal OPstart, ByVal I, ByVal Time, Byval SD)
   If Time<1 Then Time=1
   Dim lwi   
   lwi=Cint(Right(OPstart,2))
      LedWmem(lwi,1)=1
      LedWmem(lwi,2)=0
      LedWmem(lwi,3)=0
      LedWmem(lwi,4)=0
      LedWmem(lwi,6)=0
      LedWmem(lwi,7)=0
      LedWmem(lwi,8)=2
      LedWmem(lwi,11)=I ' Ivalue mem
      LedWmem(lwi,5)=I ' To Ivalue
      'Inrements per step
      LedWmem(lwi,9)=(I)/(Time/LWTime) ' time steps
      LedWmem(lwi,12)=Int(SD/LWTime)
      If LedWActive=1 then LedControl.Command = "S" & LedWn(lwi) & ":1"' Turn the output on
End Sub

'-----------------------------------------------------------------------------
'-----------------------------------------------------------------------------
Sub LedWTimer_Timer()
     If LedWActive=0 Then Exit Sub
   Dim lwi
   dim tnum,count,count2
   
   For lwi=0 To LedWMaxOutputs
      count=0:count2=0
      If LedWmem(lwi,8)>0 Then
      Select Case LedWmem(lwi,8)
         Case 3 'OnOff
            If LedWmem(lwi,12)>0 Then 'Start Delay
               LedWmem(lwi,12)=LedWmem(lwi,12)-1
               count=1
            Else
               If LedWmem(lwi,1) <> LedWmem(lwi,5) Then
                  LedWmem(lwi,5) = LedWmem(lwi,1)
                  If LedWmem(lwi,1) = 0 Then
                    ' textbox2.text=  "S" & LedWn(lwi) & ":0"
                     LedControl.Command = "S" & LedWn(lwi) & ":0"' Turn the output off
                  Else
                     LedControl.Command = "S" & LedWn(lwi) & ":1"' Turn the output on
                    ' textbox2.text=  "S" & LedWn(lwi) & ":1"
                  End If
               End If
            End If
         Case 1 'RGB
            If LedWmem(lwi,12)>0 Then 'Start Delay
               LedWmem(lwi,12)=LedWmem(lwi,12)-1
               count=1
            Else
               If LedWmem(lwi,10)<>LedWmem(lwi,5) Then
                  LedWmem(lwi,10)=LedWmem(lwi,10)+LedWmem(lwi,9)
                  count=count+1:count2=1
                  'R
                  If LedWmem(lwi,9)<0 Then
                     IF  LedWmem(lwi,10)<LedWmem(lwi,5) Then
                        LedWmem(lwi,10)=LedWmem(lwi,5)
                        count=count-1
                     End If
                  Else
                     IF  LedWmem(lwi,10)>LedWmem(lwi,5) Then
                        LedWmem(lwi,10)=LedWmem(lwi,5)
                        count=count-1
                     End If
                  End If
               End If
                  'G
               If LedWmem(lwi+1,10)<>LedWmem(lwi+1,5) Then
                  LedWmem(lwi+1,10)=LedWmem(lwi+1,10)+LedWmem(lwi+1,9)
                  count=count+1:count2=1
                  If LedWmem(lwi+1,9)<0 Then
                     IF  LedWmem(lwi+1,10)<LedWmem(lwi+1,5) Then
                        LedWmem(lwi+1,10)=LedWmem(lwi+1,5)
                        count=count-1
                     End If
                  Else
                     IF  LedWmem(lwi+1,10)>LedWmem(lwi+1,5) Then
                        LedWmem(lwi+1,10)=LedWmem(lwi+1,5)
                        count=count-1
                     End If
                  End If
               End If
                  'B
               If LedWmem(lwi+2,10)<>LedWmem(lwi+2,5) Then
                  LedWmem(lwi+2,10)=LedWmem(lwi+2,10)+LedWmem(lwi+2,9)
                  count=count+1:count2=1
                  If LedWmem(lwi+2,9)<0 Then
                     IF  LedWmem(lwi+2,10)<LedWmem(lwi+2,5) Then
                        LedWmem(lwi+2,10)=LedWmem(lwi+2,5)
                        count=count-1
                     End If
                  Else
                     IF  LedWmem(lwi+2,10)>LedWmem(lwi+2,5) Then
                        LedWmem(lwi+2,10)=LedWmem(lwi+2,5)
                        count=count-1
                     End If
                  End If
               End If
               If count2=1 Then
                 ' textbox2.text=  "RGB:" & LedWn(lwi) & "," & LedWn(Int(LedWmem(lwi,10)))& "," & LedWn(Int(LedWmem(lwi+1,10)))& "," & LedWn(Int(LedWmem(lwi+2,10)))
                  LedControl.Command = "RGB:" & LedWn(lwi) & "," & LedWn(Int(LedWmem(lwi,10)))& "," & LedWn(Int(LedWmem(lwi+1,10)))& "," & LedWn(Int(LedWmem(lwi+2,10)))
               End If
            End If
         Case 2' Intensity
            If LedWmem(lwi,12)>0 Then 'Start Delay
               LedWmem(lwi,12)=LedWmem(lwi,12)-1
               count=1
            Else
               If LedWmem(lwi,10)<>LedWmem(lwi,5) Then
                  LedWmem(lwi,10)=LedWmem(lwi,10)+LedWmem(lwi,9)
                  count=count+1:count2=1
                  'R
                  If LedWmem(lwi,9)<0 Then
                     IF  LedWmem(lwi,10)<LedWmem(lwi,5) Then
                        LedWmem(lwi,10)=LedWmem(lwi,5)
                        count=count-1
                     End If
                  Else
                     IF  LedWmem(lwi,10)>LedWmem(lwi,5) Then
                        LedWmem(lwi,10)=LedWmem(lwi,5)
                        count=count-1
                     End If
                  End If
               End If
               If count2=1 Then
                 ' textbox2.text=  "P" & LedWn(lwi) & ":" & LedWn(Int(LedWmem(lwi,10)))
                  LedControl.Command = "P" & LedWn(lwi) & ":" & LedWn(Int(LedWmem(lwi,10)))
               End If
          End If
      End Select
      If count=0 Then
        If LedWmem(lwi,2)<1 Then
         LedWmem(lwi,8) = 0  
        Else
           If LedWmem(lwi,1) = 0 Then
              LedWmem(lwi,4)=LedWmem(lwi,4)-1
              If LedWmem(lwi,4) < 1 Then
                 LedWmem(lwi,4)=LedWmem(lwi,7)
                  Select Case LedWmem(lwi,8)
                    Case 3
                       LedWmem(lwi,1)=Int(Abs(LedWmem(lwi,1)-1))
                    Case 1
                       LedWmem(lwi,1)=Int(Abs(LedWmem(lwi,1)-1))
                       LedWmem(lwi,9)=-LedWmem(lwi,9):LedWmem(lwi+1,9)=-LedWmem(lwi+1,9):LedWmem(lwi+2,9)=-LedWmem(lwi+2,9)
                       LedWmem(lwi,5)=LedWmem(lwi,11):LedWmem(lwi+1,5)=LedWmem(lwi+1,11):LedWmem(lwi+2,5)=LedWmem(lwi+2,11)
                    Case 2
                       LedWmem(lwi,1)=Int(Abs(LedWmem(lwi,1)-1))
                       LedWmem(lwi,9)=-LedWmem(lwi,9)
                       LedWmem(lwi,5)=LedWmem(lwi,11)
                 End Select
              End If
           Else
              LedWmem(lwi,3)=LedWmem(lwi,3)-1
              IF LedWmem(lwi,3) < 1 Then
                 LedWmem(lwi,3)=LedWmem(lwi,6)
                 Select Case LedWmem(lwi,8)
                    Case 3
                       LedWmem(lwi,1)=Int(Abs(LedWmem(lwi,1)-1))
                    Case 1
                       LedWmem(lwi,1)=Int(Abs(LedWmem(lwi,1)-1))
                       LedWmem(lwi,9)=-LedWmem(lwi,9):LedWmem(lwi+1,9)=-LedWmem(lwi+1,9):LedWmem(lwi+2,9)=-LedWmem(lwi+2,9)
                       LedWmem(lwi,5)=0:LedWmem(lwi+1,5)=0:LedWmem(lwi+2,5)=0
                    Case 2
                        LedWmem(lwi,1)=Int(Abs(LedWmem(lwi,1)-1))
                       LedWmem(lwi,9)=-LedWmem(lwi,9)
                       LedWmem(lwi,5)=0
                 End Select
                 If LedWmem(lwi,2)<999 Then LedWmem(lwi,2)=LedWmem(lwi,2)-1
              End If
           End If    
        End If
     End If
     If LedWmem(lwi,8)=1 Then lwi=lwi+2
     End If
   Next
End Sub
'*****************************************************************************
'*****************************************************************************
'*****************************************************************************